## Examples

We'll make a change to the default InstanceType of a CloudFromation stack.

    lono cfn preview my-stack

The output should look similiar to this:

    Generating CloudFormation source code diff...
    Running: colordiff /tmp/existing_cfn_template.yml output/templates/ec2.yml
    14c14
    <     Default: t2.small
    ---
    >     Default: t2.micro
    Generating CloudFormation Change Set for preview.....
    CloudFormation preview for 'ec2' stack update. Changes:
    Modify AWS::EC2::Instance: EC2Instance i-07e939db65120fb75

The preview includes colors:

<img src="/img/reference/lono-cfn-preview.png" alt="Stack Update" class="doc-photo">

There are two types of "diffs" in the preview.

1. Source code diff of the templates. This is generated by downloading the current CloudFormation template and comparing it with the locally generated one using `colordiff`.
2. CloudFormation Change Set list of changes. This is generated using [AWS CloudFormation Change Set](https://medium.com/boltops/a-simple-introduction-to-cloudformation-part-4-change-sets-dry-run-mode-c14e41dfeab7) feature.
