# Lono CloudFormation Starter README

This folder contains the code that represents your infrastructure built with CloudFormation.

## Overview

The CloudFormations templates are generated by a tool called [lono](https://lono.cloud/).

## Updating the Infrastructure

The general steps to update the infrastructure:

1. Add and edit the blueprints
2. Generate CloudFormation templates
3. Deploy the stack

Steps 2-3 are automated with lono and performed together with:

    lono cfn deploy STACK_NAME

Here are some useful flags:

    lono cfn deploy STACK_NAME --sure

More info: [lono cfn deploy](https://lono.cloud/reference/lono-cfn-deploy/)

## Structure

The structure of a lono project looks like this:

More info: [Project Structure](https://lono.cloud/docs/structure/)

## Generating Templates from Blueprints

If you would like to just generate the templates and not update the CloudFormation stack you can do so with:

    lono generate BLUEPRINT_NAME

## Configs

You may want to take a look at the configs folder to change params and variables. For example:

* configs/demo/params
* configs/demo/variables

## Deploy

To launch the stack:

    lono cfn deploy demo

## More help

You can get help by adding `-h` to the end of commands.

    lono cfn update -h

Help is also provided in the [Lono Docs](https://lono.cloud/docs/).
